Subject: [Sip] Via maddr (again)

From: "Paul D.Smith" <[email-masked]>
Date: Mon, 1 Mar 2004 10:11:48 -0000

Jonathan,

I've just been looking at the use of maddr's in Via headers and found a
relevent discussion from the SIP mailing list (appended to this e-mail).  If
I read your final response correctly, you indicate that the maddr parameter
in a Via could be a hostname.

However reading RFC3261, 18.1.1 says...

   A client that sends a request to a multicast address MUST add the
   "maddr" parameter to its Via header field value containing the
   destination multicast address, and for IPv4, SHOULD add the "ttl"
   parameter with a value of 1.  Usage of IPv6 multicast is not defined
   in this specification, and will be a subject of future
   standardization when the need arises.

Similarly, section 18.2.2 says...

      o  Otherwise, if the Via header field value contains a "maddr"
         parameter, the response MUST be forwarded to the address listed
         there, using the port indicated in "sent-by", or port 5060 if
         none is present.  If the address is a multicast address, the
         response SHOULD be sent using the TTL indicated in the "ttl"
         parameter, or with a TTL of 1 if that parameter is not present.

Both of these texts refer to the multicast _address_ and not a hostname
which resolves to an address.  Nor is there any mention of any DNS access
such as an A/AAAA record look-up.

So two questions.

1. Can a Via maddr really contain a hostname instead of an IP address?
2. If the answer to #1 is "yes", does RFC3261 require additional clarifying
text to emphasize this and point out that a DNS look-up is required.

If the answer to #1 is "yes" then I feel the answer to #2 should also be
"yes" since, unless I've missed something, nothing in 18.2.2 (apart from
perhaps the maddr) requires a DNS look-up.  It is only when RFC3263 gets
involved, on failing to send a response, that DNS is required.

Regards,
Paul D. Smith

Paul D.Smith
Network Protocols Group 
Data Connection Ltd (DCL)
Tel: +44 20 8366 1177  Email: [email-masked] 
Fax: +44 20 8363 1039  Web:   http://www.dataconnection.com

-----Original Message-----
From: Jonathan Rosenberg [mailto:[email-masked]]
Sent: 24 January 2003 22:02
To: Christer Holmberg
Cc: [email-masked]; [email-masked]
Subject: Re: [Sip] Via maddr

The intent of 18.2.2 is indeed NOT to use the SRV processing. In fact, 
if you look at 18.1, the only way that the maddr gets set is through 
multicast, and thus the intent is that maddr is really for multicast. 
THis need not be an IP address, since DNS names can refer to multicast 
addresses (sip.mcast.net).

Originally, the maddr in the URI was the same - meant just for 
multicast. However, in the absence of a suitable loose routing 
mechanism, it got continually abused until the common case was for that, 
and not for multicast at all. Doing that properly required SRV 
processing. Now, we have thankfully deprecated the usage of maddr for 
that purpose, but older rfc2543 elements might construct such URIs, and 
so RFC3263 continues to perform the SRV processing for the maddr in the 
request URI, when present.

Thus the asymetry.

-Jonathan R.

Christer Holmberg wrote:
> Any comments on this?
> 
> Regards,
> 
> Christer Holmberg
> Ericsson Finland
> 
> Brett Tate wrote:
> 
> 
>>>I appologise if this has been discussed
>>>before, but at least I didn't find it in
>>>my mail box (I admit I didn't check the
>>>archieve on the web).
>>
>>I posted a related question to sip-implementors;
>>however I never got a reply.
>>
>>http://lists.cs.columbia.edu/pipermail/sip-implementors/2002-October/00405
2.
>>html
>>
>>
>>>Chapter 18.2.2 in RFC3261 talks about the
>>>routing of responses, using the Via maddr,
>>>received and sent-by parameters.
>>>
>>>My question is regarding maddr. When reading
>>>the text, I get the picture that only
>>>IP addresses are used in maddr. At least the
>>>text doesn't mention the SRV RFC, which it does
>>>for sent-by, and it says that the default port
>>>is 5060. However, the ABNF defines maddr as
>>>"host", which can also be a domain name.
>>
>>maddr can be a domain name.  The text appears
>>to disable the ability to perform an SRV query
>>associated with the Via maddr.  However I never
>>got an answer concerning if this was intentional.
>>
>>_______________________________________________
>>Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
>>This list is for NEW development of the core SIP Protocol
>>Use [email-masked] for questions on current sip
>>Use [email-masked] for new developments on the application of sip
> 
> 
> _______________________________________________
> Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
> This list is for NEW development of the core SIP Protocol
> Use [email-masked] for questions on current sip
> Use [email-masked] for new developments on the application of sip
> 

-- 
Jonathan D. Rosenberg, Ph.D.                72 Eagle Rock Ave.
Chief Scientist                             First Floor
dynamicsoft                                 East Hanover, NJ 07936
[email-masked]                     FAX:   (973) 952-5050
http://www.jdrosen.net                      PHONE: (973) 952-5000
http://www.dynamicsoft.com

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip